fl

{
2010.10.14
LCD YHY024006A(controller:ILI9325)
}

10 wconstant _cs         \ P16
11 wconstant _rs         \ P17
12 wconstant _wr         \ P18
13 wconstant _reset      \ P19
wvariable tmp
wvariable state
variable dot_mask
wvariable rect_data
0ffffff0 l, 3ffffffc l, 7ffffffe l, 7ffffffe l, ffffffff l,
ffffffff l, ffffffff l, ffffffff l, ffffffff l, ffffffff l,  
ffffffff l, ffffffff l, ffffffff l, ffffffff l, ffffffff l,  
ffffffff l, ffffffff l, ffffffff l, ffffffff l, ffffffff l,  
ffffffff l, ffffffff l, ffffffff l, ffffffff l, ffffffff l,  
ffffffff l, 7ffffffe l, 7ffffffe l, 3ffffffc l, 0ffffff0 l,

wvariable a_da
\ wvariable arrow_data
fffe7fff l, fffe7fff l, fffe7fff l, fffc3fff l, fffc3fff l,
fff81fff l, fff81fff l, fff00fff l, fff00fff l, ffe007ff l,
ffe007ff l, ffc003ff l, ffc003ff l, ff8001ff l, ff8001ff l,
ff0000ff l, ff0000ff l, fe00007f l, fe00007f l, fc00003f l,

1 _cs lshift constant _csm 
1 _rs lshift constant _rsm
1 _wr lshift constant _wrm
1 _reset lshift constant _resetm

: _cs_l _csm _maskoutlo ;
: _cs_h _csm _maskouthi ;
: _rs_l _rsm _maskoutlo ;
: _rs_h _rsm _maskouthi ;
: _wr_l _wrm _maskoutlo ;
: _wr_h _wrm _maskouthi ;
: _reset_l _resetm _maskoutlo ;
: _reset_h _resetm _maskouthi ;

: lcd_out
_cs_l _rs_l ffff0000 outa COG@ and or outa COG! _wr_l _wr_h _rs_h    \ write register index
ffff0000 outa COG@ and or outa COG! _wr_l _wr_h _cs_h          \ write register data
;

: lcd_out_gram
_cs_l _rs_l ffff0000 outa COG@ and or outa COG! _wr_l _wr_h _rs_h    \ write register index (write)
ffff0000 outa COG@ and or outa COG! _wr_l _wr_h                \ write 1st data
ffff0000 outa COG@ and or outa COG! _wr_l _wr_h _cs_h          \ write 2nd data
;

: YHY024006A_init
0 14 0 do dup pinout 1+ loop drop		\ P0 - P19 output set
14 delms       \ wait 20msec
_cs_h _rs_h _wr_h _reset_h    \ cs=rs=wr=reset=H 
5 delms        \ wait 5msec
_reset_l
10 delms
_reset_h
14 delms

0 1       lcd_out   \ SS and SM
700 2     lcd_out   \ 1line inversion
\ c020 3    lcd_out   \ GRAM eritr derection / set RGB(BGR=0)
c038 3    lcd_out
0 4       lcd_out   \ resize
207 8     lcd_out   \ back porch and front porch
0 9       lcd_out   \ 
0 a       lcd_out
0 c       lcd_out
0 d       lcd_out
0 f       lcd_out

0 10      lcd_out
7 11      lcd_out
0 12      lcd_out
0 13      lcd_out
c8 delms
1490 10   lcd_out
227 11    lcd_out
32 delms
1c 12     lcd_out
32 delms
a00 13    lcd_out
f 29      lcd_out
d 2b      lcd_out
32 delms
0 20      lcd_out
0 21      lcd_out

0 30      lcd_out
203 31    lcd_out
1 32      lcd_out
205 35    lcd_out
20c 366   lcd_out
07 37     lcd_out
405 38    lcd_out
707 39    lcd_out
502 3c    lcd_out
1008 3d   lcd_out

0 50      lcd_out
ef 51     lcd_out
0 52      lcd_out
13f 53    lcd_out
a700 60   lcd_out
1 61      lcd_out
0 6a      lcd_out

0 80      lcd_out
0 81      lcd_out
0 82      lcd_out
0 83      lcd_out
0 84      lcd_out
0 85      lcd_out

10 90     lcd_out
600 92    lcd_out
133 7     lcd_out
0 state W!
;

: color_data                      \ B(6bit)G(6bit)R(6bit) --> 2nd data(16bit) 1st data(2bit)
swap 6 lshift or over f and c lshift or swap 4 rshift
22 lcd_out_gram
;
: clear
f0 0 do  
     140 0 do
              3f 3f 3f color_data     \ botom:B center:G top:R
     loop
loop
;
: harf_draw
33 52 lcd_out 64 53 lcd_out
78 50 lcd_out db 51 lcd_out
78 20 lcd_out       \ y
33 21 lcd_out
1f40 0 do 0 3f 0 color_data loop
;
: dot_display
80000000 dot_mask L!
\ 20 0 do dup dot_mask L@ and 0= if 3f 3f 3f color_data
20 0 do dup dot_mask L@ and 0= if state W@ 0= if 3f 3f 3f 
                                              else 0 0 3f
                                              then  color_data
                               else 3f 0 0 color_data
                               then
        dot_mask dup L@ 1 rshift swap L!                   
loop       
drop 
;
: button
rect_data 2 + tmp W!
78 52 lcd_out 97 53 lcd_out
   50 lcd_out    51 lcd_out
   20 lcd_out
78 21 lcd_out
tmp W@
1e 0 do dup L@ dot_display 4 + loop drop
;

: arrow
a_da 2 + tmp W!
78 52 lcd_out 97 53 lcd_out
55 50 lcd_out 6a 51 lcd_out
55 20 lcd_out
78 21 lcd_out
tmp W@
14 0 do dup L@ dot_display 4 + loop drop
;

: arrow1
a_da 4e + tmp W!
78 52 lcd_out 97 53 lcd_out
87 50 lcd_out 9c 51 lcd_out
87 20 lcd_out
78 21 lcd_out
tmp W@
14 0 do dup L@ dot_display 4 - loop drop
;
